Bug 837268 - Review Request: CardManager - network game for collectable card games
Review Request: CardManager - network game for collectable card games
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: gil cattaneo
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-03 06:37 EDT by jiri vanek
Modified: 2012-07-26 18:30 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-07-18 11:56:28 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
puntogil: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description jiri vanek 2012-07-03 06:37:22 EDT
Spec URL: http://jvanek.fedorapeople.org/CardManagerReview/CardManager.spec
SRPM URL: http://jvanek.fedorapeople.org/CardManagerReview/CardManager-1-1.fc16.src.rpm
Description: This is free, open source multiplatform (java) application which llows you to play ANY card game. 
The game is designed especially to play collectible card games like Magic the Gathering or Doomtrooper over network.
To play those games you need to own (scanned) images of card, which are not part of this package.
Some can be easily downloadable from internet, but be aware of copyrights.
The default deck and background is free of copyright
Also please feel free to add your own backgrounds to 
~/CardManager/data/backgrounds and of course enhance
collection under ~/CardManager/collection

Fedora Account System Username: jvanek

I would like to add this game both for f16 and f17, however java have changed its version meanwile, so there are testing rpms for both fedoras/javas
http://jvanek.fedorapeople.org/CardManagerReview/jdk6/
http://jvanek.fedorapeople.org/CardManagerReview/jdk7/

I'm offering per review for this stuff (with simmilar simplicity;)
Comment 1 jiri vanek 2012-07-09 07:27:20 EDT
SPECS/CardManager.spec
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
RPMS/noarch/CardManager-1-1.fc16.noarch.rpm
CardManager.noarch: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.noarch: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
CardManager.noarch: W: no-manual-page-for-binary CardManager
CardManager.noarch: E: use-of-home-in-%post
CardManager.noarch: E: use-of-home-in-%postun
CardManager.noarch: W: class-path-in-manifest /usr/share/java/CardManager.jar
1 packages and 0 specfiles checked; 2 errors, 4 warnings.
RPMS/noarch/CardManager-javadoc-1-1.fc16.noarch.rpm
CardManager-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
1 packages and 0 specfiles checked; 0 errors, 1 warnings.
SRPMS/CardManager-1-1.fc16.src.rpm
CardManager.src: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.src: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


CardManager.noarch: W: no-manual-page-for-binary CardManager - gui helpCardManager.noarch: E: use-of-home-in-%post and CardManager.noarch: E: use-of-home-in-%postun - just in echo command
CardManager.noarch: W: class-path-in-manifest /usr/share/java/CardManager.jar - classpath is empty, and correctly set by jpackage
Comment 2 gil cattaneo 2012-07-11 08:48:23 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== Generic ====
[ ]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[ ]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[ ]: MUST Package contains no bundled libraries.
[ ]: MUST Changelog in prescribed format.
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
[ ]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files javadoc section. This is OK if
     packaging for EPEL5. Otherwise not needed
[ ]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains a properly installed %{name}.desktop using desktop-
     file-install file if it is a GUI application.
[ ]: MUST Package requires other packages for directories it uses.
[ ]: MUST Package uses nothing in %doc for runtime.
[ ]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[ ]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[ ]: MUST License field in the package spec file matches the actual license.
[ ]: MUST License file installed when any subpackage combination is installed.
[ ]: MUST Package consistently uses macros (instead of hard-coded directory
     names).
[x]: MUST Package is named according to the Package Naming Guidelines.
[ ]: MUST Package does not generate any conflict.
[ ]: MUST Package obeys FHS, except libexecdir and /usr/target.
[ ]: MUST Package must own all directories that it creates.
[ ]: MUST Package does not own files or directories owned by other packages.
[ ]: MUST Package installs properly.
[ ]: MUST Requires correct, justified where necessary.
[!]: MUST Rpmlint output is silent.

rpmlint CardManager-1-1.fc18.noarch.rpm

CardManager.noarch: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.noarch: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
CardManager.noarch: W: no-manual-page-for-binary CardManager
CardManager.noarch: E: use-of-home-in-%post
CardManager.noarch: E: use-of-home-in-%postun
CardManager.noarch: W: uncompressed-zip /usr/share/java/CardManager.jar
1 packages and 0 specfiles checked; 2 errors, 4 warnings.


rpmlint CardManager-1-1.fc18.src.rpm

CardManager.src: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.src: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


rpmlint CardManager-javadoc-1-1.fc18.noarch.rpm

CardManager-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
1 packages and 0 specfiles checked; 0 errors, 1 warnings.


[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
/home/gil/837268/CardManager_sources.zip :
  MD5SUM this package     : fd917a8408da1526167a3b536ca7f112
  MD5SUM upstream package : fd917a8408da1526167a3b536ca7f112

[ ]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: MUST Package contains a SysV-style init script if in need of one.
[x]: MUST File names are valid UTF-8.
[ ]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[ ]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[ ]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[ ]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[ ]: SHOULD Latest version is packaged.
[ ]: SHOULD Package does not include license text files separate from
     upstream.
[ ]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[ ]: SHOULD Scriptlets must be sane, if used.
[!]: SHOULD SourceX / PatchY prefixed with %{name}.
     Note: Source0: http://cardmanager.wz.cz/CardManager_sources.zip
     (CardManager_sources.zip) Patch0: removeManifestEntries.patch
     (removeManifestEntries.patch)
[x]: SHOULD SourceX is a working URL.
[ ]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[ ]: SHOULD %check is present and all tests pass.
[ ]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


==== Java ====
[ ]: MUST If source tarball includes bundled jar/class files these need to be
     removed prior to building
[x]: MUST Packages have proper BuildRequires/Requires on jpackage-utils
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: MUST Javadoc subpackages have Requires: jpackage-utils
[x]: MUST Javadocs are placed in %{_javadocdir}/%{name} (no -%{version}
     symlink)
[ ]: SHOULD Package has BuildArch: noarch (if possible)
[ ]: SHOULD Package uses upstream build method (ant/maven/etc.)


==== Maven ====
[x]: MUST Old add_to_maven_depmap macro is not being used
[ ]: MUST If package contains pom.xml files install it (including depmaps)
     even when building with ant

Issues:
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files javadoc section. This is OK if
     packaging for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: MUST Rpmlint output is silent.

rpmlint CardManager-1-1.fc18.noarch.rpm

CardManager.noarch: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.noarch: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
CardManager.noarch: W: no-manual-page-for-binary CardManager
CardManager.noarch: E: use-of-home-in-%post
CardManager.noarch: E: use-of-home-in-%postun
CardManager.noarch: W: uncompressed-zip /usr/share/java/CardManager.jar
1 packages and 0 specfiles checked; 2 errors, 4 warnings.


rpmlint CardManager-1-1.fc18.src.rpm

CardManager.src: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.src: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
1 packages and 0 specfiles checked; 0 errors, 2 warnings.


rpmlint CardManager-javadoc-1-1.fc18.noarch.rpm

CardManager-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
1 packages and 0 specfiles checked; 0 errors, 1 warnings.


See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
Comment 3 gil cattaneo 2012-07-11 09:06:29 EDT
hi
Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
beginning of %install
change
cp -r dist/javadoc $RPM_BUILD_ROOT%{_javadocdir}/%{name}
with
cp -r dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}

the subpackage javadoc should got the license file and remove the %%defattr(-,root,root,-) This is OK if
packaging for EPEL5.

edit /%{_datadir}/%{name} in %{_datadir}/%{name}

%files
%{_datadir}/pixmaps/CardManager.png
%{_datadir}/applications/CardManager.desktop
%{_datadir}/%{name}
%attr(755,root,root) %{_bindir}/CardManager
%{_javadir}/*
%doc license.txt

%files javadoc
%{_javadocdir}/%{name}
%doc license.txt



remove %clean section
Comment 4 jiri vanek 2012-07-12 12:57:09 EDT
hi! 
Thank you for very careful review!

most issues have been fixed:
http://jvanek.fedorapeople.org/CardManagerReview/round2/CardManager.spec                                                                http://jvanek.fedorapeople.org/CardManagerReview/round2/CardManager-1-1.fc16.src.rpm
http://jvanek.fedorapeople.org/CardManagerReview/round2/CardManager-1-1.fc16.noarch.rpm
http://jvanek.fedorapeople.org/CardManagerReview/round2/CardManager-javadoc-1-1.fc16.noarch.rpm     

namely:
cp -r dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}
FIXED - added asterix

the subpackage javadoc should got the license file and remove the %%defattr(-,root,root,-) This is OK if
FIXED - both

edit /%{_datadir}/%{name}
FIXED - removed leading slash

[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
FIXED - clean removed

[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files javadoc section. This is OK if
     packaging for EPEL5. Otherwise not needed
FIXED - global defattr removed


Two not fixed:

1) See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
and
Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
beginning of %install

REASON: I must be blind but there is already
%install
rm -rf $RPM_BUILD_ROOT
...

2)[!]: MUST Rpmlint output is silent.

rpmlint CardManager-1-1.fc18.noarch.rpm

CardManager.noarch: W: spelling-error %description -l en_US multiplatform -> multiform, formulation, formulator
CardManager.noarch: W: spelling-error %description -l en_US downloadable -> down loadable, down-loadable, download able
CardManager-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, 
CardManager.noarch: W: no-manual-page-for-binary CardManager
CardManager.noarch: E: use-of-home-in-%post
CardManager.noarch: E: use-of-home-in-%postun
CardManager.noarch: W: uncompressed-zip /usr/share/java/CardManager.jar


Well this rule was added recently and is going to be removed or touched as to strict. I hope I have good excuse for all issues by rpmlint:
2.a multiplatform - I consider this word as correct
2.b downloadable - likewise
2.c Javadocs - likewise - copy-pasted from guidelines anyway;)
2.d no-manual-page-for-binary - gui application with own gui-help
2.e uncompressed-zip - what I can see in rpm is zip with mor ethen 50% of compression. Bug in rpmlint?
2.f CardManager.noarch: E: use-of-home-in-%postun and %post - This is most discusable issue. I'm using it just for echo so I believe that it can stay in as serving good purpose. However, if you really insist I will remove it.

Thank you for your review again!
Comment 5 gil cattaneo 2012-07-12 13:06:48 EDT
hi 
should remove rm -rf $RPM_BUILD_ROOT

should/must become
%install

#desktop
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps


thanks
Comment 7 gil cattaneo 2012-07-12 16:18:46 EDT
Looks good now.

================
*** APPROVED ***
================
Comment 8 jiri vanek 2012-07-13 03:34:44 EDT
New Package SCM Request
=======================
Package Name: CardManager
Short Description: network game for collectible card games
Owners: jvanek
Branches: f16 f17
InitialCC:
Comment 9 gil cattaneo 2012-07-13 07:10:14 EDT
ops
can you  remove %post %%postun scripts?

CardManager.noarch: E: use-of-home-in-%post
CardManager.noarch: E: use-of-home-in-%postun


and add to InitialCC: java-sig
regards
Comment 10 jiri vanek 2012-07-13 08:59:44 EDT
"2.f CardManager.noarch: E: use-of-home-in-%postun and %post - This is most discusable issue. I'm using it just for echo so I believe that it can stay in as serving good purpose. However, if you really insist I will remove it."

As I told I use it only for echo and this echo is not bad.  If you really insists (But not only because rpmlint is complaining :o) I will replace this scriplets with something like

%post
  echo "This application is using your your_home/CardManager directory as location with custom collections"
  echo "If this directory exists it will be used, otherwise it will be created during first launch"


%postun
  echo "This application is using your your_home/CardManager directory as location with custom collections"
  echo "This directory was not removed during uninstall to not touch your private collections"

But imho the original scriplets with ~ are little bit better.
Comment 11 gil cattaneo 2012-07-13 09:32:31 EDT
no insists than ...
but should you set the InitialCC field....?
Comment 12 jiri vanek 2012-07-13 09:55:39 EDT
New Package SCM Request
=======================
Package Name: CardManager
Short Description: network game for collectible card games
Owners: jvanek
Branches: f16 f17
InitialCC: java-sig
Comment 13 Jason Tibbitts 2012-07-13 13:32:26 EDT
Scriptlets really shouldn't do any output, and certainly not intentional output.

yum is going to flag that output as an error. yum-cron is going to mail it to the admin (where it's almost certainly not useful).  There's a short thread at http://lists.fedoraproject.org/pipermail/packaging/2009-March/005797.html.  The scriptlet examples also take the care to redirect output to /dev/null.

However, this isn't written in the guidelines anywhere.  I will file a ticket to get that fixed now.
Comment 14 Gwyn Ciesla 2012-07-14 22:39:38 EDT
Git done (by process-git-requests).
Comment 15 jiri vanek 2012-07-16 06:09:25 EDT
Thank to all participants!
Package pushed and built. The post and postun have been removed.
Comment 16 Fedora Update System 2012-07-16 06:20:16 EDT
CardManager-1-1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/CardManager-1-1.fc17
Comment 17 Fedora Update System 2012-07-16 06:20:55 EDT
CardManager-1-1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/CardManager-1-1.fc16
Comment 18 Fedora Update System 2012-07-17 13:19:14 EDT
Package CardManager-1-1.fc17:
* should fix your issue,
* was pushed to the Fedora 17 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing CardManager-1-1.fc17'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-10694/CardManager-1-1.fc17
then log in and leave karma (feedback).
Comment 19 Fedora Update System 2012-07-26 18:28:00 EDT
CardManager-1-1.fc16 has been pushed to the Fedora 16 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 20 Fedora Update System 2012-07-26 18:30:11 EDT
CardManager-1-1.fc17 has been pushed to the Fedora 17 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.